IF OBJECT_ID('[HM].[hm_DW_PowiazaniaDostawPozycji]', 'P') IS NOT NULL DROP PROCEDURE [HM].[hm_DW_PowiazaniaDostawPozycji]
GO
CREATE PROCEDURE HM.hm_DW_PowiazaniaDostawPozycji






@poz int
AS

declare @superkoryg int
declare @super int
declare @lp smallint
declare @bufor smallint
declare @przychod smallint

select @superkoryg = ISNULL(MG.iddokkoryg, MG.id), @super = MZ.super, @lp = MZ.lp, @bufor = MG.bufor,
       @przychod = case when (MG.flag & 0x0100) <> 0 then 1 else 0 end
from MG join MZ on MG.id = MZ.super where MZ.id = @poz

declare @tblPWM TABLE
  (iddw int primary key, ilosc decimal(24,6), idpw int, flagpw smallint, datapw datetime, idkoryg int,
   ilmag decimal(24,6), wartmag decimal(24,2), ilbuf decimal(24,6), wartbuf decimal(24,2), ilrez decimal(24,6), wartrez decimal(24,2))

declare @tblPWA TABLE
  (id int, iddw int, ilosc decimal(24,6), wartosc decimal(24,2), idmz int, super int, primary key (iddw, super))

if @bufor = 1
 if @superkoryg = @super
  begin
   if @przychod = 1
    begin

     insert @tblPWM (iddw, ilosc, idpw, flagpw, datapw, idkoryg, ilmag, wartmag, ilbuf, wartbuf, ilrez, wartrez)
     select PW.iddw, PW.ilosc, PW.id, PW.flag, PW.data, 0, 0.0, 0.0, PW.ilosc, PW.wartosc, 0.0, 0.0
     from PW where PW.typ = 39 and PW.idmg = @poz
    end
   else
    begin

     insert @tblPWM (iddw, ilosc, idpw, flagpw, datapw, idkoryg, ilmag, wartmag, ilbuf, wartbuf, ilrez, wartrez)
     select PW.iddw, 0.0, 0, 0, NULL, 0, 0.0, 0.0, 0.0, 0.0, PW.ilosc, PW.wartosc
     from PW join RZ on (PW.typ = 26 and PW.idmg = RZ.id) where RZ.idpozrz = @poz and RZ.bazadokrz = 33 and RZ.bazapozrz = 37
    end
  end
 else
  begin

    insert @tblPWA
    select MIN(PW.id) as id, PW.iddw, SUM(PW.ilosc), SUM(PW.wartosc + ISNULL(PWK.wartosc, 0.0)), MZ.id as idmz, MZ.super
    from PW join MZ on (PW.typ = 37 and PW.idmg = MZ.id)
    left join
    (select SUM(PW.wartosc) as wartosc, PW.idkoryg
     from PW where PW.subtyp = 90 group by PW.idkoryg) as PWK on PWK.idkoryg = PW.id
    where MZ.lp = @lp and MZ.superkoryg = @superkoryg and MZ.super < @super
    group by MZ.id, MZ.super, PW.iddw

    declare @tblPWB TABLE
      (id int, iddw int, ilosc decimal(24,6), wartosc decimal(24,2), idmz int, super int, primary key (iddw, super))

    insert @tblPWB
    select PW.id, PW.iddw, PW.ilosc, PW.wartosc, MZ.id as idmz, MZ.super
    from PW join MZ on (PW.typ = 39 and PW.idmg = MZ.id)
    where MZ.id = @poz

    declare @tblPWR TABLE
      (id int, iddw int, ilosc decimal(24,6), wartosc decimal(24,2), idmz int, super int, primary key (iddw, super))

    insert @tblPWR
    select PW.id, PW.iddw, PW.ilosc, PW.wartosc, MZ.id as idmz, MZ.super
    from PW join RZ on (PW.typ = 26 and PW.idmg = RZ.id)
    join MZ on (RZ.bazadokrz = 33 and RZ.bazapozrz = 37 and RZ.idpozrz = MZ.id)
    where RZ.idpozrz = @poz

    insert @tblPWM (iddw, ilosc, idpw, flagpw, datapw, idkoryg, ilmag, wartmag, ilbuf, wartbuf, ilrez, wartrez)
    select PWA.iddw, ISNULL(PW.ilosc, 0.0), ISNULL(PW.id, 0), ISNULL(PW.flag, 0), PW.data, ISNULL(PW3.idkoryg, 0),
           ISNULL(PW3.ilosc, 0.0), ISNULL(PW3.wartosc, 0.0), ISNULL(PW1.ilosc, 0.0), ISNULL(PW1.wartosc, 0.0), ISNULL(PW2.ilosc, 0.0), ISNULL(PW2.wartosc, 0.0)
    from ( select iddw from @tblPWA union select iddw from @tblPWB union select iddw from @tblPWR) as PWA
    left join (select id, iddw, ilosc, wartosc from @tblPWB) as PW1 on PW1.iddw = PWA.iddw
    left join PW on PW.id = PW1.id
    left join (select iddw, ilosc, wartosc from @tblPWR) as PW2 on PW2.iddw = PWA.iddw
    left join (select iddw, SUM(ilosc) as ilosc, SUM(wartosc) as wartosc, MIN(id) as idkoryg
		       from @tblPWA group by iddw) as PW3 on PW3.iddw = PWA.iddw
  end
else
 if @superkoryg = @super
  begin

    insert @tblPWM (iddw, ilosc, idpw, flagpw, datapw, idkoryg, ilmag, wartmag, ilbuf, wartbuf, ilrez, wartrez)
    select PW.iddw, PW.ilosc, PW.id, PW.flag, PW.data, PW.id, PW.ilosc, PW.wartosc + ISNULL(PWK.wartosc, 0.0), 0.0, 0.0, 0.0, 0.0
    from PW left join
    (select PW.idkoryg, SUM(PW.wartosc) as wartosc
     from PW where PW.subtyp = 90 group by PW.idkoryg) as PWK on PWK.idkoryg = PW.id
    where PW.typ = 37 and PW.idmg = @poz
  end
 else
  begin

    insert @tblPWA
    select MIN(PW.id) as id, PW.iddw, SUM(PW.ilosc), SUM(PW.wartosc + ISNULL(PWK.wartosc, 0.0)), MZ.id as idmz, MZ.super
    from PW join MZ on (PW.typ = 37 and PW.idmg = MZ.id)
    left join
    (select SUM(PW.wartosc) as wartosc, PW.idkoryg
     from PW where PW.subtyp = 90 group by PW.idkoryg) as PWK on PWK.idkoryg = PW.id
    where MZ.lp = @lp and MZ.superkoryg = @superkoryg and MZ.super <= @super
    group by MZ.id, MZ.super, PW.iddw

    insert @tblPWM (iddw, ilosc, idpw, flagpw, datapw, idkoryg, ilmag, wartmag, ilbuf, wartbuf, ilrez, wartrez)
    select PWA.iddw, ISNULL(PW.ilosc, 0.0), ISNULL(PW.id, 0), ISNULL(PW.flag, 0), PW.data, PWA.idkoryg, PWA.ilosc, PWA.wartosc, 0.0, 0.0, 0.0, 0.0
    from (select iddw, SUM(ilosc) as ilosc, SUM(wartosc) as wartosc, MIN(id) as idkoryg
		  from @tblPWA group by iddw) as PWA
    left join (select id, iddw from @tblPWA where idmz = @poz) as PW1 on PW1.iddw = PWA.iddw
    left join PW on PW.id = PW1.id
  end

select DW.id, DW.flag, DW.typ, DW.kod, DW.numer, DW.idtw, DW.data, DW.ilosc, DW.iloscdosp, DW.cena, DW.wartoscdosp, DW.magazyn, DW.iloscPz, DW.stan, DW.wartoscst, DW.iddw,
     PWM.ilosc, PWM.idpw, PWM.flagpw, PWM.datapw, PWM.idkoryg, PWM.ilmag, PWM.wartmag, PWM.ilbuf, PWM.wartbuf, PWM.ilrez, PWM.wartrez, DW.krajPochodzenia
from DW join @tblPWM as PWM on DW.id = PWM.iddw

